
import java.util.Scanner;

class Main {

    public static void main(String[] args) {

        // 控制台输入
        Scanner scanner = new Scanner(System.in);
        String s = scanner.nextLine();
        String p = scanner.nextLine();

        scanner.close();
        // 调用方法
        boolean res = isMatch(s,p);
        // 输出结果
        System.out.println(res);

    }

    /**
     *
     * @param s
     * @param p
     * @return
     */
    public static boolean isMatch(String s, String p) {
        int m = s.length();
        int n = p.length();

        boolean[][] f = new boolean[m + 1][n + 1];
        f[0][0] = true;
        for (int i = 0; i <= m; ++i) {
            for (int j = 1; j <= n; ++j) {
                if (p.charAt(j - 1) == '*') {
                    f[i][j] = f[i][j - 2];
                    if (matches(s, p, i, j - 1)) {
                        f[i][j] = f[i][j] || f[i - 1][j];
                    }
                } else {
                    if (matches(s, p, i, j)) {
                        f[i][j] = f[i - 1][j - 1];
                    }
                }
            }
        }
        return f[m][n];
    }

    public static boolean matches(String s, String p, int i, int j) {
        if (i == 0) {
            return false;
        }
        if (p.charAt(j - 1) == '.') {
            return true;
        }
        return s.charAt(i - 1) == p.charAt(j - 1);
    }
}

/*

1
aa
a
false

2
aa
a*
true

3
ab
.*
true

4
abab
ab
false

5
abcabc
a.*c
true

6
123456
123*
false

7
123456
123.*
true



8
abcdef
a.*e
false


9
abcdef
a.*f
true


10
1234321
1.*1
true

 */